Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetGunHeading.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetGunHeading.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetGunHeading.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,14 +38,11 @@
 
     [StorableConstructor]
-    private GetGunHeading(bool deserializing) : base(deserializing) { }
-    private GetGunHeading(GetGunHeading original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected GetGunHeading(bool deserializing) : base(deserializing) { }
+    protected GetGunHeading(GetGunHeading original, Cloner cloner) : base(original, cloner) { }
 
     public GetGunHeading()
       : base("GetGunHeading", "Returns the direction that the robot's gun is facing, in degrees.") {
-      this.Prefix = "getGunHeading(";
-      this.Suffix = ")";
+      Prefix = "getGunHeading(";
+      Suffix = ")";
     }
 
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetHeading.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetHeading.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetHeading.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,14 +38,11 @@
 
     [StorableConstructor]
-    private GetHeading(bool deserializing) : base(deserializing) { }
-    private GetHeading(GetHeading original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected GetHeading(bool deserializing) : base(deserializing) { }
+    protected GetHeading(GetHeading original, Cloner cloner) : base(original, cloner) { }
 
     public GetHeading()
       : base("GetHeading", "Returns the direction that the robot's body is facing, in degrees.") {
-      this.Prefix = "getHeading(";
-      this.Suffix = ")";
+      Prefix = "getHeading(";
+      Suffix = ")";
     }
 
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetRadarHeading.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetRadarHeading.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetRadarHeading.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,13 +38,11 @@
 
     [StorableConstructor]
-    private GetRadarHeading(bool deserializing) : base(deserializing) { }
-    private GetRadarHeading(GetRadarHeading original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected GetRadarHeading(bool deserializing) : base(deserializing) { }
+    protected GetRadarHeading(GetRadarHeading original, Cloner cloner) : base(original, cloner) { }
 
     public GetRadarHeading()
       : base("GetRadarHeading", "Returns the direction that the robot's radar is facing, in degrees.") {
-      this.Prefix = "getRadarHeading(";
-      this.Suffix = ")";
+      Prefix = "getRadarHeading(";
+      Suffix = ")";
     }
 
@@ -53,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetX.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetX.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetX.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,14 +38,11 @@
 
     [StorableConstructor]
-    private GetX(bool deserializing) : base(deserializing) { }
-    private GetX(GetX original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected GetX(bool deserializing) : base(deserializing) { }
+    protected GetX(GetX original, Cloner cloner) : base(original, cloner) { }
 
     public GetX()
       : base("GetX", "Returns the X position of the robot. (0,0) is at the bottom left of the battlefield.") {
-      this.Prefix = "getX(";
-      this.Suffix = ")";
+      Prefix = "getX(";
+      Suffix = ")";
     }
 
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetY.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetY.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetY.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,14 +38,11 @@
 
     [StorableConstructor]
-    private GetY(bool deserializing) : base(deserializing) { }
-    private GetY(GetY original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected GetY(bool deserializing) : base(deserializing) { }
+    protected GetY(GetY original, Cloner cloner) : base(original, cloner) { }
 
     public GetY()
       : base("GetY", "Returns the Y position of the robot. (0,0) is at the bottom left of the battlefield.") {
-      this.Prefix = "getY(";
-      this.Suffix = ")";
+      Prefix = "getY(";
+      Suffix = ")";
     }
 
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/INumericalMethod.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/INumericalMethod.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/INumericalMethod.cs	(revision 10011)
@@ -20,8 +20,5 @@
 #endregion
 
-
-
 namespace HeuristicLab.Problems.Robocode {
-  public interface INumericalMethod {
-  }
+  public interface INumericalMethod { }
 }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Program.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Program.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Program.cs	(revision 10011)
@@ -32,8 +32,6 @@
 
     [StorableConstructor]
-    private Program(bool deserializing) : base(deserializing) { }
-    private Program(Program original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Program(bool deserializing) : base(deserializing) { }
+    protected Program(Program original, Cloner cloner) : base(original, cloner) { }
 
     public Program()
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Stat.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Stat.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Stat.cs	(revision 10011)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class Stat : CodeNode {
+    public override int MinimumArity { get { return 1; } }
+    public override int MaximumArity { get { return 1; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected Stat(bool deserializing) : base(deserializing) { }
+    protected Stat(Stat original, Cloner cloner) : base(original, cloner) { }
+
+    public Stat() : base("Statement", "A statement.") { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Stat(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/ElseStat.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/ElseStat.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/ElseStat.cs	(revision 10011)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class ElseStat : CodeNode {
+    public override int MinimumArity { get { return 1; } }
+    public override int MaximumArity { get { return 1; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected ElseStat(bool deserializing) : base(deserializing) { }
+    protected ElseStat(ElseStat original, Cloner cloner) : base(original, cloner) { }
+
+    public ElseStat()
+      : base("ElseStatement", "An ElseStatement.") {
+      Prefix = "else";
+      Suffix = "";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ElseStat(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return string.IsNullOrEmpty(result)
+        ? string.Empty
+        : Prefix + Environment.NewLine + result + Environment.NewLine + Suffix;
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/IfStat.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/IfStat.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/IfStat.cs	(revision 10011)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class IfStat : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 3; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected IfStat(bool deserializing) : base(deserializing) { }
+    protected IfStat(IfStat original, Cloner cloner) : base(original, cloner) { }
+
+    public IfStat()
+      : base("IfStatement", "An if statement.") {
+      Prefix = "if (";
+      Suffix = ")";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IfStat(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string condition = string.Empty, ifTrue = string.Empty, ifElse = string.Empty;
+      foreach (var c in children) {
+        if (c.Symbol is LogicalExpression)
+          condition = ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+        else if (c.Symbol is Stat)
+          ifTrue = ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+        else if (c.Symbol is ElseStat || c.Symbol is EmptyEvent || c.Symbol is DoNothing)
+          ifElse = ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+        else throw new ArgumentException("Unexpected children.", "children");
+      }
+      return Prefix + condition + Suffix + Environment.NewLine + ifTrue + Environment.NewLine + ifElse + Environment.NewLine;
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/WhileStat.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/WhileStat.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Statements/WhileStat.cs	(revision 10011)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class WhileStat : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected WhileStat(bool deserializing) : base(deserializing) { }
+    protected WhileStat(WhileStat original, Cloner cloner) : base(original, cloner) { }
+
+    public WhileStat()
+      : base("WhileStat", "A while statement.") {
+      Prefix = "while (";
+      Suffix = ")";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new WhileStat(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string condition = string.Empty, ifTrue = string.Empty;
+      foreach (var c in children) {
+        if (c.Symbol is LogicalExpression)
+          condition = ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+        else if (c.Symbol is Stat || c.Symbol is EmptyEvent || c.Symbol is DoNothing)
+          ifTrue = ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+        else throw new ArgumentException("Unexpected children.", "children");
+      }
+      return Prefix + condition + Suffix + Environment.NewLine + ifTrue + Environment.NewLine;
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Tank.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Tank.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Tank.cs	(revision 10011)
@@ -20,5 +20,7 @@
 #endregion
 
-
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -28,5 +30,5 @@
   [StorableClass]
   public class Tank : CodeNode {
-    public override int MinimumArity { get { return 7; } }
+    public override int MinimumArity { get { return 2; } }
     public override int MaximumArity { get { return 7; } }
 
@@ -38,20 +40,19 @@
 
     [StorableConstructor]
-    private Tank(bool deserializing) : base(deserializing) { }
-    private Tank(Tank original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Tank(bool deserializing) : base(deserializing) { }
+    protected Tank(Tank original, Cloner cloner) : base(original, cloner) { }
 
     public Tank()
       : base("Tank", "The root of a Robocode Tank program.") {
-      this.Prefix = "package Evaluation;" +
-                    "\r\nimport robocode.*;" +
-                    "\r\nimport robocode.Robot;" +
-                    "\r\nimport robocode.util.*;" +
-                    "\r\nimport static robocode.util.Utils.normalRelativeAngleDegrees;" +
-                    "\r\nimport java.awt.*;" +
-                    "\r\n\r\n" +
-                    "\r\npublic class output extends AdvancedRobot {\r\n";
-      this.Suffix = "\r\n}";
+      Prefix =
+@"package Evaluation;
+import robocode.*;
+import robocode.Robot;
+import robocode.util.*;
+import static robocode.util.Utils.normalRelativeAngleDegrees;
+import java.awt.*;
+
+public class output extends AdvancedRobot {";
+      Suffix = "}";
     }
 
@@ -60,9 +61,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Ahead.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Ahead.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Ahead.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,13 +38,11 @@
 
     [StorableConstructor]
-    private Ahead(bool deserializing) : base(deserializing) { }
-    private Ahead(Ahead original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Ahead(bool deserializing) : base(deserializing) { }
+    protected Ahead(Ahead original, Cloner cloner) : base(original, cloner) { }
 
     public Ahead()
       : base("Ahead", "Immediately moves your robot ahead (forward) by distance measured in pixels.") {
-      this.Prefix = "setAhead(";
-      this.Suffix = ");";
+      Prefix = "setAhead(";
+      Suffix = ");";
     }
 
@@ -53,20 +51,17 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
       var enumerator = children.GetEnumerator();
+      if (!enumerator.MoveNext()) throw new System.Exception("Ahead was not given a child.");
 
-      if (!enumerator.MoveNext()) throw new System.Exception("Ahead was not given a child.");
       var symbol = enumerator.Current.Symbol;
-
-      if (!(symbol is Number || symbol is NumericalOperation || symbol is NumericalExpression))
-        throw new System.Exception("Ahead was given a child of type " + symbol.GetType().ToString() +
-            ". The expected child must be of type " + typeof(Number).ToString() + " or " +
-            typeof(NumericalOperation).ToString() + " or " +
-            typeof(NumericalExpression).ToString() + ".");
+      if (!(symbol is NumericalExpression))
+        throw new System.Exception("Ahead was given a child of type " + symbol.GetType() +
+            ". The expected child must be of type " + typeof(NumericalExpression) + ".");
 
       string result = ((CodeNode)symbol).Interpret(enumerator.Current, enumerator.Current.Subtrees);
       if (enumerator.MoveNext()) throw new System.Exception("Ahead was given more than one child.");
 
-      return this.Prefix + result + this.Suffix;
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Back.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Back.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/Back.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,12 +38,11 @@
 
     [StorableConstructor]
-    private Back(bool deserializing) : base(deserializing) { }
-    private Back(Back original, Cloner cloner)
-      : base(original, cloner) { }
+    protected Back(bool deserializing) : base(deserializing) { }
+    protected Back(Back original, Cloner cloner) : base(original, cloner) { }
 
     public Back()
       : base("Back", "Immediately moves your robot backward by distance measured in pixels.") {
-      this.Prefix = "setBack(";
-      this.Suffix = ");";
+      Prefix = "setBack(";
+      Suffix = ");";
     }
 
@@ -52,20 +51,17 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
       var enumerator = children.GetEnumerator();
+      if (!enumerator.MoveNext()) throw new System.Exception("Back was not given a child.");
 
-      if (!enumerator.MoveNext()) throw new System.Exception("Back was not given a child.");
       var symbol = enumerator.Current.Symbol;
-
-      if (!(symbol is Number || symbol is NumericalOperation || symbol is NumericalExpression))
-        throw new System.Exception("Back was given a child of type " + symbol.GetType().ToString() +
-            ". The expected child must be of type " + typeof(Number).ToString() + " or " +
-            typeof(NumericalOperation).ToString() + " or " +
-            typeof(NumericalExpression).ToString() + ".");
+      if (!(symbol is NumericalExpression))
+        throw new System.Exception("Back was given a child of type " + symbol.GetType() +
+            ". The expected child must be of type " + typeof(NumericalExpression) + ".");
 
       string result = ((CodeNode)symbol).Interpret(enumerator.Current, enumerator.Current.Subtrees);
       if (enumerator.MoveNext()) throw new System.Exception("Back was given more than one child.");
 
-      return this.Prefix + result + this.Suffix;
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/DoNothing.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/DoNothing.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Void Methods/DoNothing.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,12 +38,8 @@
 
     [StorableConstructor]
-    private DoNothing(bool deserializing) : base(deserializing) { }
-    private DoNothing(DoNothing original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected DoNothing(bool deserializing) : base(deserializing) { }
+    protected DoNothing(DoNothing original, Cloner cloner) : base(original, cloner) { }
 
-    public DoNothing()
-      : base("DoNothing", "Do nothing this turn, meaning that the robot will skip it's turn.") {
-    }
+    public DoNothing() : base("DoNothing", "Do nothing this turn, meaning that the robot will skip it's turn.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -51,6 +47,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return "";
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return ";";
     }
   }
